install 25 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728729730731732733734735736737738739740741742743744745746747748749750751752753754755756757758759760761762763764765766767768769770771772773774775776777778779780781782783784785786787788789790791792793794795796797798799800801802803804805806807808809810811812813814815816817818819820821822823824825826
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. comprobarError() {
  11. # comprobarError exitNum codeNum extraInfo
  12. # 1xx: Servidor Web
  13. # 2xx: Base de Datos
  14. # 3xx: PHP
  15. # 4xx: SSL/TLS
  16. # 5xx: MediaWiki
  17. # 6xx: Moodle
  18. # 7xx: Actualizaciones automáticas
  19. # 8xx: Dependencias
  20. # 9xx: Servicios
  21. type="ERROR"
  22. exitNum=$1
  23. codeNum=$2
  24. extraInfo=$3
  25. case $codeNum in
  26. 1)
  27. error="$type $codeNum:\tInstalación interrumpida por el usuario.\n"
  28. ;;
  29. 2)
  30. error="$type $codeNum:\tError interno (selección express).\n"
  31. ;;
  32. 3)
  33. error="$type $codeNum:\tError interno (selección avanzada).\n"
  34. ;;
  35. 100)
  36. error="$type $codeNum:\tError interno (selección del servidor web).\n"
  37. ;;
  38. 101)
  39. error="\n$type $codeNum:\tError al instalar Apache2.\nDetalles:\n$extraInfo\n"
  40. ;;
  41. 102)
  42. error="\n$type $codeNum:\tError al instalar Nginx.\nDetalles:\n$extraInfo\n"
  43. ;;
  44. 103)
  45. error="\n$type $codeNum:\tError al nstalar repositorio 'epel-release'.\nDetalles:\n$extraInfo\n"
  46. ;;
  47. 104)
  48. error="\n$type $codeNum:\tError interno (instalación Apache2).\n"
  49. ;;
  50. 105)
  51. error="\n$type $codeNum:\tError interno (instalación Nginx).\n"
  52. ;;
  53. 200)
  54. error="$type $codeNum:\tError interno (selección de base de datos).\n"
  55. ;;
  56. 201)
  57. error="\n$type $codeNum:\tError al instalar MySQL.\nDetalles:\n$extraInfo\n"
  58. ;;
  59. 202)
  60. error="\n$type $codeNum:\tError al instalar MariaDB.\nDetalles:\n$extraInfo\n"
  61. ;;
  62. 203)
  63. error="\n$type $codeNum:\tError interno (instalación MySQL).\n"
  64. ;;
  65. 204)
  66. error="\n$type $codeNum:\tError interno (instalación MariaDB).\n"
  67. ;;
  68. 205)
  69. error="\n$type $codeNum:\t$DIST no incluye MySQL en sus repositorios.\n"
  70. ;;
  71. 206)
  72. type="WARNING"
  73. error="$type $codeNum:\tUsuario 'root' ya dispone de contraseña.\n"
  74. ;;
  75. 207)
  76. error="$type $codeNum:\tImposible cambiar la contraseña de 'root'.\n"
  77. ;;
  78. 208)
  79. error="$type $codeNum:\tImposible desactivar acceso 'root' desde el exterior.\n"
  80. ;;
  81. 209)
  82. error="$type $codeNum:\tImposible eliminar usuarios anónimos.\n"
  83. ;;
  84. 210)
  85. type="WARNING"
  86. error="$type $codeNum:\tImposible eliminar bases de datos de pruebas.\n"
  87. ;;
  88. 211)
  89. type="WARNING"
  90. error="$type $codeNum:\tImposible eliminar los permisos de las bases de datos de pruebas.\n"
  91. ;;
  92. 212)
  93. error="$type $codeNum:\tImposible recargar base de datos.\n"
  94. ;;
  95. 300)
  96. error="$type $codeNum:\tError interno (instalación PHP).\n"
  97. ;;
  98. 301)
  99. error="$type $codeNum:\tError interno (Web Server no seleccionado).\n"
  100. ;;
  101. 302)
  102. error="$type $codeNum:\tError al instalar PHP.\nDetalles:\n$extraInfo\n"
  103. ;;
  104. 303)
  105. error="$type $codeNum:\tError al instalar Repositorio Remi.\nDetalles:\n$extraInfo\n"
  106. ;;
  107. 304)
  108. error="$type $codeNum:\tSistema Operativo no compatible con PHP-7.2 ($OS $DIST $REV).\n"
  109. ;;
  110. 800)
  111. error="$type $codeNum:\tEs necesario ser root ('sudo $0').\n"
  112. ;;
  113. 801)
  114. error="$type $codeNum:\t'whiptail' no instalado.\n"
  115. ;;
  116. 802)
  117. error="$type $codeNum:\t'hostnamectl' no instalado.\n"
  118. ;;
  119. 803)
  120. error="$type $codeNum:\t'apt-get' no instalado.\n"
  121. ;;
  122. 804)
  123. error="$type $codeNum:\t'yum' no instalado.\n"
  124. ;;
  125. 805)
  126. error="\n$type $codeNum:\tImposible actualizar repositorio\nDetalles:\n$extraInfo.\n"
  127. ;;
  128. 806)
  129. error="$type $codeNum:\t'ufw' no instalado.\n"
  130. ;;
  131. 807)
  132. error="$type $codeNum:\t'firewall-cmd' no instalado.\n"
  133. ;;
  134. 808)
  135. error="$type $codeNum:\t'tput' no instalado.\n"
  136. ;;
  137. 900)
  138. error="$type $codeNum:\tError interno (habilitar servicio).\n"
  139. ;;
  140. 901)
  141. error="$type $codeNum:\tImposible encender servicio '$extraInfo'.\n"
  142. ;;
  143. 902)
  144. error="$type $codeNum:\tImposible habilitar servicio '$extraInfo' durante el arranque.\n"
  145. ;;
  146. *)
  147. error="ERROR 13:\tError interno (comprobación de errores)\n"
  148. exitNum=1
  149. codeNum=13
  150. ;;
  151. esac
  152. if [ $exitNum -ne 0 ];then
  153. printf "$error"
  154. if [ $type = "ERROR" ];then
  155. exit $codeNum
  156. fi
  157. fi
  158. unset error exitNum codeNum type
  159. }
  160. OSInfo() {
  161. #printf "Detectando SO..."
  162. OS=$(uname -s)
  163. if [ $OS = "Linux" ]; then
  164. OS="GNU/Linux"
  165. if [ -f /etc/os-release ]; then
  166. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  167. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  168. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  169. VERSION=$(grep ^VERSION_ID= /etc/os-release | cut -d = -f 2 | cur -d '"' -f 2)
  170. for i in $ID_LIKE; do
  171. #printf "$i\n"
  172. case $i in
  173. debian|ubuntu)
  174. debianOS=true
  175. break
  176. ;;
  177. rhel|fedora)
  178. rhelOS=true
  179. break
  180. ;;
  181. *)
  182. debianOS=false
  183. rhelOS=false
  184. ;;
  185. esac
  186. done
  187. elif [ -f /etc/debian-version ]; then
  188. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  189. DIST="Debian"
  190. REV=""
  191. ID_LIKE="debian"
  192. debianOS=true
  193. elif [ -f /etc/redhat-release ]; then
  194. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  195. DIST="Red-Hat"
  196. REV=""
  197. ID_LIKE="rhel"
  198. rhelOS=true
  199. else
  200. # Other Linux (No Soportado)
  201. DIST=""
  202. REV=""
  203. ID_LIKE=""
  204. fi
  205. else
  206. # UNIX, OS X, ... (No Soportado)
  207. DIST=$OS
  208. REV=""
  209. fi
  210. #printf " $OS $DIST $REV\n"
  211. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)"\n"$(df -h | grep ^/dev/mapper)
  212. }
  213. comprobarRoot() {
  214. comprobarError $(id -u) 800
  215. }
  216. comprobarDependencias() {
  217. # Comprobamos whiptail
  218. which whiptail > /dev/null 2>&1
  219. comprobarError $? 801
  220. # Comprobamos hostnamectl
  221. which hostnamectl > /dev/null 2>&1
  222. comprobarError $? 802
  223. # Comprobamos tput
  224. which tput > /dev/null 2>&1
  225. comprobarError $? 808
  226. if [ $debianOS = true ];then
  227. # Comprobamos apt-get
  228. which apt-get > /dev/null 2>&1
  229. comprobarError $? 803
  230. # Actualizamos base de datos del repositorio
  231. printf "Actualizando repositorio APT..."
  232. result=$(apt-get -q -y update)
  233. comprobarError $? 805 $result
  234. printf " OK.\n"
  235. # Comprobamos Firewall (ufw)
  236. which ufw > /dev/null 2>&1
  237. comprobarError $? 806
  238. fi
  239. if [ $rhelOS = true ]; then
  240. # Comprobamos yum
  241. which yum > /dev/null 2>&1
  242. comprobarError $? 804
  243. # Actualizamos base de datos del repositorio
  244. printf "Actualizando repositorio YUM..."
  245. result=$(yum -y makecache 2>&1)
  246. comprobarError $? 805 $result
  247. printf " OK.\n"
  248. # Comprobamos Firewall (firewall-cmd)
  249. which firewall-cmd > /dev/null 2>&1
  250. comprobarError $? 807
  251. fi
  252. }
  253. inicializarVariables() {
  254. debianOS=false
  255. rhelOS=false
  256. apacheOn=false
  257. nginxOn=false
  258. mySQLOn=false
  259. mariaDBOn=false
  260. phpOn=false
  261. mediaWikiOn=false
  262. moodleOn=false
  263. actualizacionesOn=false
  264. progreso=0
  265. progresoTotal=0
  266. }
  267. instalacionExpress() {
  268. apacheOn=true
  269. mariaDBOn=true
  270. phpOn=true
  271. mediaWikiOn=true
  272. moodleOn=true
  273. actualizacionesOn=true
  274. progresoTotal=15
  275. # Preguntas mínimas
  276. establecerFQDN
  277. leerSQLPasswd
  278. }
  279. mostrarBienvenida() {
  280. ANCHO=$(tput cols)
  281. ALTO=$(tput lines)
  282. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  283. whiptail --title "ERROR S.O. NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Salir"
  284. exit 1
  285. fi
  286. whiptail --title "INSTALACION MEDIAWIKI" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  287. comprobarError $? 1
  288. }
  289. mostrarExpress() {
  290. express=$(whiptail --title "INSTALACION EXPRESS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nLa instalación express instala Apache2, MariaDB, PHP-7, Let's Encrypt, MediaWiki, Moodle y actualizaciones automáticas.\nSeleccione el tipo de instalación que desee:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  291. "Express" "Instalación rápida" ON \
  292. "Avanzada" "Permite escoger todas las opciones disponibles" OFF \
  293. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  294. comprobarError $? 1
  295. case $express in
  296. Express)
  297. instalacionExpress
  298. # DECIDIR QUÉ OPCIONES SON LAS MÍNIMAS
  299. ;;
  300. Avanzada)
  301. mostrarAvanzada
  302. ;;
  303. *)
  304. comprobarError 1 2
  305. ;;
  306. esac
  307. }
  308. mostrarAvanzada() {
  309. componentes=$(whiptail --title "INSTALACION AVANZADA" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 6 \
  310. "LAMP" "Linux + Apache + MySQL/MariaDB + PHP" ON \
  311. "LEMP" "Linux + Nginx + MySQL/MariaDB + PHP" ON \
  312. # "WebServer" "Instalar servidor web http/https" ON \
  313. # "Database" "Instalar una base de datos SQL" ON \
  314. # "PHP" "Instala PHP7" ON \
  315. "SSL/TLS" "Instalar certificados para activar HTTPS" ON \
  316. "MediaWiki" "Instalar wiki con MediaWiki" ON \
  317. "Moodle" "Instalar campus virtual con Moodle" ON \
  318. "Actualizaciones" "Programar actualizaciones automáticas" ON \
  319. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  320. comprobarError $? 1
  321. # Mejora: autodetección de componentes ya instalados
  322. for i in $componentes; do
  323. case $i in
  324. \"LAMP\")
  325. apacheOn=true
  326. establecerFQDN
  327. mostrarDatabase
  328. phpOn=true
  329. progresoTotal=$((progresoTotal + 6))
  330. ;;
  331. \"LEMP\")
  332. nginxOn=true
  333. establecerFQDN
  334. mostrarDatabase
  335. phpOn=true
  336. progresoTotal=$((progresoTotal + 6))
  337. ;;
  338. # \"WebServer\")
  339. # mostrarWebServer
  340. # progresoTotal=$((progresoTotal + 2))
  341. # ;;
  342. # \"Database\")
  343. # mostrarDatabase
  344. # progresoTotal=$((progresoTotal + 2))
  345. # ;;
  346. # \"PHP\")
  347. # phpOn=true
  348. # progresoTotal=$((progresoTotal + 2))
  349. # ;;
  350. \"SSL/TLS\")
  351. # 2 Opciones: Let's Encrypt o Autofirmado
  352. progresoTotal=$((progresoTotal + 2))
  353. ;;
  354. \"MediaWiki\")
  355. mediaWikiOn=true
  356. progresoTotal=$((progresoTotal + 2))
  357. ;;
  358. \"Moodle\")
  359. moodleOn=true
  360. progresoTotal=$((progresoTotal + 2))
  361. ;;
  362. \"Actualizaciones\")
  363. actualizacionesOn=true
  364. progresoTotal=$((progresoTotal + 1))
  365. ;;
  366. *)
  367. comprobarError 1 3
  368. ;;
  369. esac
  370. done
  371. progresoTotal=$((progresoTotal + 2))
  372. }
  373. mostrarWebServer() {
  374. # DEPRECATED
  375. webServer=$(whiptail --title "SERVIDOR WEB" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge el servidor web que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  376. "Apache" "Instalar el servidor web Apache2" ON \
  377. "Nginx" "Instalar el servidor web Nginx" OFF \
  378. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  379. comprobarError $? 1
  380. case $webServer in
  381. Apache)
  382. apacheOn=true
  383. ;;
  384. Nginx)
  385. nginxOn=true
  386. ;;
  387. *)
  388. comprobarError 1 100
  389. ;;
  390. esac
  391. # Otras opciones (FQDN)
  392. establecerFQDN
  393. }
  394. establecerFQDN() {
  395. while [ -z $hostname ]; do
  396. hostname=$(whiptail --title "FQDN" --inputbox "El nombre de dominio principal (FQDN) de este servidor es:\n"$(hostname)"\n\nQuieres cambiarlo por otro?" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Cambiar" --cancel-button "No Cambiar" 3>&1 1>&2 2>&3)
  397. if [ $? -eq 0 ] && [ ! -z $hostname ]; then
  398. hostnamectl set-hostname $hostname
  399. else
  400. hostname=$(hostname)
  401. fi
  402. done
  403. #printf "\nHostname: $hostname\n"
  404. }
  405. instalarApache() {
  406. if [ $debianOS = true ];then
  407. result=$(apt-get -q -y install apache2 2>&1)
  408. comprobarError $? 101 $result
  409. elif [ $rhelOS = true ]; then
  410. result=$(yum -y install httpd 2>&1)
  411. comprobarError $? 101 $result
  412. else
  413. comprobarError 1 104
  414. fi
  415. }
  416. instalarNginx() {
  417. if [ $debianOS = true ];then
  418. result=$(apt-get -q -y install nginx 2>&1)
  419. comprobarError $? 102 $result
  420. elif [ $rhelOS = true ]; then
  421. # Hay que instalar primero otro repositorio
  422. result=$(yum -y install epel-release)
  423. comprobarError $? 103 $result
  424. result=$(yum -y install nginx 2>&1)
  425. comprobarError $? 102 $result
  426. else
  427. comprobarError 1 105
  428. fi
  429. }
  430. mostrarDatabase() {
  431. if [ $debianOS = true ]; then
  432. database=$(whiptail --title "BASE DE DATOS" --radiolist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge la base de datos que quieres usar:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) 2 \
  433. "MySQL" "Instalar la base de datos MySQL (no uso comercial)" ON \
  434. "MariaDB" "Instalar la base de datos MariaDB (fork de MySQL)" OFF \
  435. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  436. comprobarError $? 1
  437. case $database in
  438. MySQL)
  439. mySQLOn=true
  440. ;;
  441. MariaDB)
  442. mariaDBOn=true
  443. ;;
  444. *)
  445. comprobarError 1 200
  446. ;;
  447. esac
  448. elif [ $rhelOS = true ]; then
  449. whiptail --title "BASE DE DATOS" --yesno "Para su distribucion $OS $DIST $REV, sólo está disponible la base de datos MariaDB." $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --yes-button "Continuar" --no-button "Salir"
  450. comprobarError $? 1
  451. mariaDBOn=true
  452. else
  453. comprobarError 1 200
  454. fi
  455. # Otras opciones (contraseña)
  456. leerSQLPasswd
  457. }
  458. leerSQLPasswd() {
  459. control=false
  460. error=""
  461. # Leemos la contreseña (stdin) y confirmamos
  462. while [ $control = false ]; do
  463. sqlPasswd=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "$error""Introduzca la contraseña para el usuario 'root' de la base de datos:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  464. comprobarError $? 1
  465. sqlPasswd2=$(whiptail --title "CONTRASEÑA SQL" --passwordbox "Confirme la contraseña:" $((ALTO * 9 / 10)) $((ANCHO * 9 / 10)) --ok-button "Continuar" --nocancel 3>&1 1>&2 2>&3)
  466. comprobarError $? 1
  467. #printf "SQL Password 1: $sqlPasswd\n"
  468. #printf "SQL Password 2: $sqlPasswd2\n"
  469. if [ -z $sqlPasswd ] || [ -z $sqlPasswd2 ]; then
  470. error="ERROR: LA CONTRASEÑA NO PUEDE ESTAR VACIA.\n"
  471. elif [ $sqlPasswd != $sqlPasswd2 ];then
  472. error="ERROR: LAS CONTRASEÑAS NO COINCIDEN.\n"
  473. else
  474. control=true
  475. fi
  476. done
  477. #printf "SQL Password: $sqlPasswd\n"
  478. unset control error sqlPasswd2
  479. }
  480. establecerSQLPasswd() {
  481. # Establecemos SQL root passwd y securizamos BD (mysql_secure_installation)
  482. # Mejora: ¿Si ya tiene una contraseña asignada?
  483. mysql -e "FLUSH PRIVILEGES" > /dev/null 2>&1
  484. if [ $? -eq 0 ];then
  485. # Establecemos contraseña del usuario root
  486. mysql -e "UPDATE mysql.user SET Password = PASSWORD('$sqlPasswd') WHERE User = 'root'" > /dev/null 2>&1
  487. comprobarError $? 207
  488. # Desactivamos acceso root desde el exterior (solo localhost)
  489. mysql -e "DELETE FROM mysql.user WHERE User='root' AND Host NOT IN ('localhost', '127.0.0.1', '::1')" > /dev/null 2>&1
  490. comprobarError $? 208
  491. # Eliminamos todos los usuarios anónimos
  492. mysql -e "DELETE FROM mysql.user WHERE User=''" > /dev/null 2>&1
  493. comprobarError $? 209
  494. # Eliminamos bases de datos 'test'
  495. mysql -e "DROP DATABASE IF EXISTS test" > /dev/null 2>&1
  496. comprobarError $? 210
  497. # Eliminamos privilegios de la base de datos 'test'
  498. mysql -e "DELETE FROM mysql.db WHERE Db='test' OR Db='test\\_%'" > /dev/null 2>&1
  499. comprobarError $? 211
  500. # Aplicamos los cambios
  501. mysql -e "FLUSH PRIVILEGES" > /dev/null 2>&1
  502. comprobarError $? 212
  503. else
  504. comprobarError $? 206
  505. fi
  506. }
  507. instalarMySQL() {
  508. if [ $debianOS = true ];then
  509. result=$(apt-get -q -y install mysql-server mysql-client 2>&1)
  510. comprobarError $? 201 $result
  511. elif [ $rhelOS = true ];then
  512. # MySQL no disponible en RHEL. 2 opciones:
  513. # 1) Instalar un repositorio adicional
  514. # 2) No instalar MySQL en distribuciones RHEL
  515. comprobarError 1 205
  516. else
  517. comprobarError 1 203
  518. fi
  519. }
  520. instalarMariaDB() {
  521. if [ $debianOS = true ];then
  522. result=$(apt-get -q -y install mariadb-server mariadb-client 2>&1)
  523. comprobarError $? 202 $result
  524. elif [ $rhelOS = true ];then
  525. result=$(yum -y install mariadb-server mariadb 2>&1)
  526. comprobarError $? 202 $result
  527. else
  528. comprobarError 1 204
  529. fi
  530. }
  531. instalarPHP() {
  532. # Instalamos PHP-7 de forma diferente si es junto a Apache o con Nginx
  533. if [ $debianOS = true ];then
  534. if [ $apacheOn = true ]; then
  535. result=$(apt-get -q -y install php libapache2-mod-php php-mysql php-intl php-mbstring php-mcrypt openssl 2>&1)
  536. comprobarError $? 302 $result
  537. elif [ $nginxOn = true ];then
  538. result=$(apt-get -q -y install php-fpm libapache2-mod-php php-mysql php-intl php-mbstring php-mcrypt openssl 2>&1)
  539. comprobarError $? 302 $result
  540. else
  541. comprobarError 1 301
  542. fi
  543. elif [ $rhelOS = true ];then
  544. # Necesitamos un repositorio adicional para PHP-7 (EPEL-RELEASE)
  545. result=$(yum -y install epel-release)
  546. comprobarError $? 103 $result
  547. # Necesitamos un repositorio adicional para PHP-7 (REMI-RELEASE)
  548. if [ $VERSION = "7" ];then
  549. result=$(rpm -U http://rpms.famillecollet.com/enterprise/remi-release-7.rpm 2>&1)
  550. comprobarError $? 303 $result
  551. elif [ $VERSION = "6" ];then
  552. result=$(rpm -U http://rpms.famillecollet.com/enterprise/remi-release-6.rpm 2>&1)
  553. comprobarError $? 303 $result
  554. else
  555. comprobarError 1 304
  556. fi
  557. # Instalamos PHP-7.2
  558. if [ $apacheOn = true ];then
  559. result=$(yum -y install php72 php72-php-pecl-mysql php72-php-intl php72-php-mbstring php72-php-pecl-mcrypt openssl 2>&1)
  560. comprobarError 1 302 $result
  561. elif [ $nginxOn = true ];then
  562. result=$(yum -y install php72 php72-php-fpm php72-php-pecl-mysql php72-php-intl php72-php-mbstring php72-php-pecl-mcrypt openssl 2>&1)
  563. comprobarError $? 302 $result
  564. else
  565. comprobarError 1 301
  566. fi
  567. else
  568. comprobarError 1 300
  569. fi
  570. }
  571. habilitarServicio() {
  572. # Arrancamos y habilitamos el servicio (con SystemD, Upstart o SystemV)
  573. # Intentamos con systemctl (SystemD)
  574. printf "Habilitando servicio $1"
  575. if [ $# -le 0 ];then
  576. comprobarError 1 900
  577. fi
  578. which systemctl > /dev/null 2>&1
  579. if [ $? -eq 0 ]; then
  580. printf " (SystemD)..."
  581. systemctl start $1 > /dev/null 2>&1
  582. comprobarError $? 901 $1
  583. systemctl enable $1 > /dev/null 2>&1
  584. comprobarError $? 902 $1
  585. else
  586. # Intentamos con service (Upstart)
  587. which service > /dev/null 2>&1
  588. if [ $? -eq 0 ]; then
  589. printf " (Upstart)..."
  590. service $1 start > /dev/null 2>&1
  591. comprobarError $? 901 $1
  592. else
  593. # Intentamos con init.d (SystemV)
  594. printf " (SystemV)..."
  595. /etc/init.d/$1 start > /dev/null 2>&1
  596. comprobarError $? 901 $1
  597. fi
  598. # Intentamos habilitar en el arranque (Upstart)
  599. which update-rc.d > /dev/null 2>&1
  600. if [ $? -eq 0 ];then
  601. update-rc.d $1 enable
  602. comprobarError $? 902 $1
  603. else
  604. # Intentamos habilitar en el arranque (SystemV)
  605. which chkconfig > /dev/null 2>&1
  606. if [ $? -eq 0 ];then
  607. chkconfig $1 on
  608. comprobarError $? 902 $1
  609. else
  610. # ¿Qué mas opciones nos quedan?
  611. comprobarError 1 902 $1
  612. fi
  613. fi
  614. fi
  615. # Mejora: comprobar si el servicio está funcionando
  616. printf " OK.\n"
  617. }
  618. # Comprobación del sistema e inicialización
  619. comprobarRoot
  620. inicializarVariables
  621. OSInfo
  622. comprobarDependencias
  623. # Bienvenida
  624. mostrarBienvenida
  625. # Selección de componentes (express vs avanzada)
  626. mostrarExpress
  627. # Pre-configuración
  628. # Habilitar cortafuegos -> PROBLEMA: se corta la conexión ssh
  629. # Instalación
  630. # FALTA: whiptail --gauge -> Más bonito
  631. # Servidor Web
  632. if [ $apacheOn = true ]; then
  633. printf "Instalando Web Server Apache..."
  634. {
  635. printf "%s\n" $((100 * progreso / progresoTotal))
  636. instalarApache
  637. progreso=$((progreso + 1))
  638. } > >(whiptail --gauge "Instalando Web Server Apache..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  639. printf " OK.\n"
  640. elif [ $nginxOn = true ]; then
  641. printf "Instalando Web Server Nginx..."
  642. {
  643. printf "%s\n" $((100 * progreso / progresoTotal))
  644. instalarNginx
  645. progreso=$((progreso + 1))
  646. } > >(whiptail --gauge "Instalando Web Server Nginx..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  647. printf " OK.\n"
  648. fi
  649. # Base de Datos
  650. if [ $mySQLOn = true ]; then
  651. printf "Instalando Base de Datos MySQL..."
  652. {
  653. printf "%s\n" $((100 * progreso / progresoTotal))
  654. instalarMySQL
  655. progreso=$((progreso + 1))
  656. } > >(whiptail --gauge "Instalando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  657. printf " OK.\n"
  658. elif [ $mariaDBOn = true ]; then
  659. printf "Instalando Base de Datos MariaDB..."
  660. {
  661. printf "%s\n" $((100 * progreso / progresoTotal))
  662. instalarMariaDB
  663. progreso=$((progreso + 1))
  664. } > >(whiptail --gauge "Instalando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  665. printf " OK.\n"
  666. fi
  667. # PHP
  668. if [ $phpOn = true ]; then
  669. printf "Instalando PHP-7..."
  670. {
  671. printf "%s\n" $((100 * progreso / progresoTotal))
  672. instalarPHP
  673. progreso=$((progreso + 1))
  674. } > >(whiptail --gauge "Instalando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  675. printf " OK.\n"
  676. fi
  677. # SSL/TLS
  678. # Falta por implementar
  679. {
  680. printf "%s\n" $((100 * progreso / progresoTotal))
  681. sleep 2
  682. progreso=$((progreso + 1))
  683. } > >(whiptail --gauge "Instalando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  684. # MediaWiki
  685. if [ $mediaWikiOn = true ]; then
  686. printf "Instalando MediaWiki..."
  687. {
  688. printf "%s\n" $((100 * progreso / progresoTotal))
  689. sleep 2
  690. progreso=$((progreso + 1))
  691. } > >(whiptail --gauge "Instalando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  692. printf " OK.\n"
  693. fi
  694. # Moodle
  695. if [ $moodleOn = true ]; then
  696. printf "Instalando Moodle..."
  697. {
  698. printf "%s\n" $((100 * progreso / progresoTotal))
  699. sleep 2
  700. progreso=$((progreso + 1))
  701. } > >(whiptail --gauge "Instalando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  702. printf " OK.\n"
  703. fi
  704. # PRECAUCION!!!! Hay que habilitar algunos servicios antes de configurarlos
  705. # Por ejemplo: para cambiar la contraseña de root en mysql
  706. # Configuración
  707. # Configuración Apache
  708. # Virtual Hosts
  709. printf "Configurando Servidor Web..."
  710. {
  711. printf "%s\n" $((100 * progreso / progresoTotal))
  712. sleep 2
  713. progreso=$((progreso + 1))
  714. } > >(whiptail --gauge "Configurando Servidor Web..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  715. printf " OK.\n"
  716. # Configuración Database
  717. # Arrancar Base de Datos, establecer contraseña y configuración segura
  718. if [ $mySQLOn = true ];then
  719. printf "Configurando Base de Datos MySQL..."
  720. {
  721. printf "%s\n" $((100 * progreso / progresoTotal))
  722. habilitarServicio mysql
  723. establecerSQLPasswd
  724. progreso=$((progreso + 1))
  725. } > >(whiptail --gauge "Configurando Base de Datos MySQL..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  726. printf " OK.\n"
  727. fi
  728. if [ $mariaDBOn = true ];then
  729. printf "Configurando Base de Datos MAriaDB..."
  730. {
  731. printf "%s\n" $((100 * progreso / progresoTotal))
  732. habilitarServicio mariadb
  733. establecerSQLPasswd
  734. progreso=$((progreso + 1))
  735. } > >(whiptail --gauge "Configurando Base de Datos MariaDB..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  736. printf " OK.\n"
  737. fi
  738. # Configuración PHP
  739. # cgi.fix_pathinfo=0
  740. # Configurar máximo de subida de archivos
  741. printf "Configurando PHP-7..."
  742. {
  743. printf "%s\n" $((100 * progreso / progresoTotal))
  744. sleep 2
  745. progreso=$((progreso + 1))
  746. } > >(whiptail --gauge "Configurando PHP-7..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  747. printf " OK.\n"
  748. # Configuración MediWiki
  749. printf "Configurando MediaWiki..."
  750. {
  751. printf "%s\n" $((100 * progreso / progresoTotal))
  752. sleep 2
  753. progreso=$((progreso + 1))
  754. } > >(whiptail --gauge "Configurando MediaWiki..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  755. printf " OK.\n"
  756. # Configuración Moodle
  757. printf "Configurando Moodle..."
  758. {
  759. printf "%s\n" $((100 * progreso / progresoTotal))
  760. sleep 2
  761. progreso=$((progreso + 1))
  762. } > >(whiptail --gauge "Configurando Moodle..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  763. printf " OK.\n"
  764. # Arrancar y habilitar todos los servicios (SystemD, Service o SystemV)
  765. printf "Arrancando Servicios..."
  766. {
  767. printf "%s\n" $((100 * progreso / progresoTotal))
  768. sleep 2
  769. progreso=$((progreso + 1))
  770. } > >(whiptail --gauge "Arrancando Servicios..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  771. printf " OK.\n"
  772. # Añadir reglas del cortafuegos
  773. printf "Configurando Cortafuegos..."
  774. {
  775. printf "%s\n" $((100 * progreso / progresoTotal))
  776. sleep 2
  777. progreso=$((progreso + 1))
  778. } > >(whiptail --gauge "Configurando Cortafuegos..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  779. printf " OK.\n"
  780. # Configuración SSL/TLS
  781. # Generar certificados
  782. # Configurar certificados
  783. printf "Configurando SSL/TLS..."
  784. {
  785. printf "%s\n" $((100 * progreso / progresoTotal))
  786. sleep 2
  787. progreso=$((progreso + 1))
  788. } > >(whiptail --gauge "Configurando SSL/TLS..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  789. printf " OK.\n"
  790. # Configurar actualizaciones
  791. if [ $actualizacionesOn = true ]; then
  792. printf "Configurando actualizaciones automáticas..."
  793. {
  794. printf "%s\n" $((100 * progreso / progresoTotal))
  795. sleep 2
  796. progreso=$((progreso + 1))
  797. } > >(whiptail --gauge "Configurando actualizaciones automáticas..." $((ALTO * 4 / 10)) $((ANCHO * 9 / 10)) $((100 * progreso / progresoTotal)))
  798. printf " OK.\n"
  799. fi